<html>
<head>
<title>OgreVector4.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreVector4.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreVector4_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Vector4_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Vector4_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00045"></a><a class="code" href="classOgre_1_1Vector4.html">00045</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>
<a name="l00046"></a>00046     {
<a name="l00047"></a>00047     <span class="keyword">public</span>:
<a name="l00048"></a><a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">00048</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, y, <a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>, w;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classOgre_1_1Vector4.html#ae4417c4a3d52ee6fafd4a9103343958c">00051</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>()
<a name="l00052"></a>00052         {
<a name="l00053"></a>00053         }
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classOgre_1_1Vector4.html#a75b3e58bb0eccad1c21b68958a33a9fc">00055</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fW )
<a name="l00056"></a>00056             : x( fX ), y( fY ), z( fZ ), w( fW)
<a name="l00057"></a>00057         {
<a name="l00058"></a>00058         }
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classOgre_1_1Vector4.html#a2e8dae854a7801e2aaa97bbed0b27374">00060</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoordinate[4] )
<a name="l00061"></a>00061             : x( afCoordinate[0] ),
<a name="l00062"></a>00062               y( afCoordinate[1] ),
<a name="l00063"></a>00063               z( afCoordinate[2] ),
<a name="l00064"></a>00064               w( afCoordinate[3] )
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066         }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classOgre_1_1Vector4.html#a7da09ff768d847f015f3b1b9830a8043">00068</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>( <span class="keyword">const</span> <span class="keywordtype">int</span> afCoordinate[4] )
<a name="l00069"></a>00069         {
<a name="l00070"></a>00070             x = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[0];
<a name="l00071"></a>00071             y = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[1];
<a name="l00072"></a>00072             z = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[2];
<a name="l00073"></a>00073             w = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[3];
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classOgre_1_1Vector4.html#a9d6cc1b910cf8d738b306995f3b442d4">00076</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <span class="keyword">const</span> r )
<a name="l00077"></a>00077             : x( r[0] ), y( r[1] ), z( r[2] ), w( r[3] )
<a name="l00078"></a>00078         {
<a name="l00079"></a>00079         }
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classOgre_1_1Vector4.html#ada9aac749e3d93a83a0e1bb67f3a091f">00081</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaler )
<a name="l00082"></a>00082             : x( scaler )
<a name="l00083"></a>00083             , y( scaler )
<a name="l00084"></a>00084             , z( scaler )
<a name="l00085"></a>00085             , w( scaler )
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classOgre_1_1Vector4.html#a019e80f62dd12ea37b27b2d2a05aed64">00089</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00090"></a>00090             : x(rhs.x), y(rhs.y), z(rhs.z), w(1.0f)
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092         }
<a name="l00093"></a>00093 
<a name="l00096"></a><a class="code" href="classOgre_1_1Vector4.html#aa1980e262c207bcd24ca89f2db9bd061">00096</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>(<a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; other)
<a name="l00097"></a>00097         {
<a name="l00098"></a>00098             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(x, other.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>);
<a name="l00099"></a>00099             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(y, other.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>);
<a name="l00100"></a>00100             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(z, other.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>);
<a name="l00101"></a>00101             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(w, other.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00102"></a>00102         }
<a name="l00103"></a>00103     
<a name="l00104"></a><a class="code" href="classOgre_1_1Vector4.html#aa55187a08d385c6c367cc16338ad23ce">00104</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00105"></a>00105 <span class="keyword">        </span>{
<a name="l00106"></a>00106             assert( i &lt; 4 );
<a name="l00107"></a>00107 
<a name="l00108"></a>00108             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00109"></a>00109         }
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classOgre_1_1Vector4.html#a96b4c5c76a199850c8c4e61be0feed7d">00111</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113             assert( i &lt; 4 );
<a name="l00114"></a>00114 
<a name="l00115"></a>00115             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00116"></a>00116         }
<a name="l00117"></a>00117 
<a name="l00119"></a><a class="code" href="classOgre_1_1Vector4.html#ae8a0fc61bcae1449c843b3c5430cef1f">00119</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00120"></a>00120         {
<a name="l00121"></a>00121             <span class="keywordflow">return</span> &amp;x;
<a name="l00122"></a>00122         }
<a name="l00124"></a><a class="code" href="classOgre_1_1Vector4.html#a641d847ad0e066e213db1e1dadf43cee">00124</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00125"></a>00125 <span class="keyword">        </span>{
<a name="l00126"></a>00126             <span class="keywordflow">return</span> &amp;x;
<a name="l00127"></a>00127         }
<a name="l00128"></a>00128 
<a name="l00133"></a><a class="code" href="classOgre_1_1Vector4.html#a465dfb677017e546628f87470d6dbcd6">00133</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00134"></a>00134         {
<a name="l00135"></a>00135             x = rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00136"></a>00136             y = rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00137"></a>00137             z = rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00138"></a>00138             w = rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classOgre_1_1Vector4.html#a69daa0f94cfeb2c725521b1672204bf7">00143</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar)
<a name="l00144"></a>00144         {
<a name="l00145"></a>00145             x = fScalar;
<a name="l00146"></a>00146             y = fScalar;
<a name="l00147"></a>00147             z = fScalar;
<a name="l00148"></a>00148             w = fScalar;
<a name="l00149"></a>00149             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00150"></a>00150         }
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classOgre_1_1Vector4.html#ae7f48d8e2036594f4d65e2dca9fe286a">00152</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword">        </span>{
<a name="l00154"></a>00154             <span class="keywordflow">return</span> ( x == rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a> &amp;&amp;
<a name="l00155"></a>00155                 y == rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a> &amp;&amp;
<a name="l00156"></a>00156                 z == rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a> &amp;&amp;
<a name="l00157"></a>00157                 w == rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a> );
<a name="l00158"></a>00158         }
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classOgre_1_1Vector4.html#a0aa33b3bb9f3b8b8ef7037eaf43bedc8">00160</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">        </span>{
<a name="l00162"></a>00162             <span class="keywordflow">return</span> ( x != rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a> ||
<a name="l00163"></a>00163                 y != rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a> ||
<a name="l00164"></a>00164                 z != rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a> ||
<a name="l00165"></a>00165                 w != rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a> );
<a name="l00166"></a>00166         }
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classOgre_1_1Vector4.html#a59f17a6c7980f16a571f535b2c47a8fc">00168</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator = (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00169"></a>00169         {
<a name="l00170"></a>00170             x = rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00171"></a>00171             y = rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00172"></a>00172             z = rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00173"></a>00173             w = 1.0f;
<a name="l00174"></a>00174             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00175"></a>00175         }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         <span class="comment">// arithmetic operations</span>
<a name="l00178"></a><a class="code" href="classOgre_1_1Vector4.html#a0b8c03743d6b8f72149f914f03998689">00178</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00179"></a>00179 <span class="keyword">        </span>{
<a name="l00180"></a>00180             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00181"></a>00181                 x + rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00182"></a>00182                 y + rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00183"></a>00183                 z + rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00184"></a>00184                 w + rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00185"></a>00185         }
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classOgre_1_1Vector4.html#a78b1555cd0ea1bcd609086003444e614">00187</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00188"></a>00188 <span class="keyword">        </span>{
<a name="l00189"></a>00189             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00190"></a>00190                 x - rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00191"></a>00191                 y - rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00192"></a>00192                 z - rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00193"></a>00193                 w - rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00194"></a>00194         }
<a name="l00195"></a>00195 
<a name="l00196"></a><a class="code" href="classOgre_1_1Vector4.html#a931e2318675762b34e23681247220c12">00196</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00197"></a>00197 <span class="keyword">        </span>{
<a name="l00198"></a>00198             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00199"></a>00199                 x * fScalar,
<a name="l00200"></a>00200                 y * fScalar,
<a name="l00201"></a>00201                 z * fScalar,
<a name="l00202"></a>00202                 w * fScalar);
<a name="l00203"></a>00203         }
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classOgre_1_1Vector4.html#a0f3d72188da50999e3355da6fafa315b">00205</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00206"></a>00206 <span class="keyword">        </span>{
<a name="l00207"></a>00207             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00208"></a>00208                 rhs.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a> * x,
<a name="l00209"></a>00209                 rhs.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a> * y,
<a name="l00210"></a>00210                 rhs.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a> * z,
<a name="l00211"></a>00211                 rhs.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a> * w);
<a name="l00212"></a>00212         }
<a name="l00213"></a>00213 
<a name="l00214"></a><a class="code" href="classOgre_1_1Vector4.html#afd54901fd7d3379584d0abd73a455518">00214</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00215"></a>00215 <span class="keyword">        </span>{
<a name="l00216"></a>00216             assert( fScalar != 0.0 );
<a name="l00217"></a>00217 
<a name="l00218"></a>00218             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0f / fScalar;
<a name="l00219"></a>00219 
<a name="l00220"></a>00220             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00221"></a>00221                 x * fInv,
<a name="l00222"></a>00222                 y * fInv,
<a name="l00223"></a>00223                 z * fInv,
<a name="l00224"></a>00224                 w * fInv);
<a name="l00225"></a>00225         }
<a name="l00226"></a>00226 
<a name="l00227"></a><a class="code" href="classOgre_1_1Vector4.html#a50d14c785b00d8afbd124ffd0e9f0df5">00227</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00228"></a>00228 <span class="keyword">        </span>{
<a name="l00229"></a>00229             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00230"></a>00230                 x / rhs.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00231"></a>00231                 y / rhs.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00232"></a>00232                 z / rhs.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00233"></a>00233                 w / rhs.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00234"></a>00234         }
<a name="l00235"></a>00235 
<a name="l00236"></a><a class="code" href="classOgre_1_1Vector4.html#a785f4ea68705fdcca1dca8f09d4e1525">00236</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator + ()<span class="keyword"> const</span>
<a name="l00237"></a>00237 <span class="keyword">        </span>{
<a name="l00238"></a>00238             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00239"></a>00239         }
<a name="l00240"></a>00240 
<a name="l00241"></a><a class="code" href="classOgre_1_1Vector4.html#a2123966b60d70dd14e7d165cbb47dba8">00241</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator - ()<span class="keyword"> const</span>
<a name="l00242"></a>00242 <span class="keyword">        </span>{
<a name="l00243"></a>00243             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(-x, -y, -z, -w);
<a name="l00244"></a>00244         }
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classOgre_1_1Vector4.html#ab1ae444cc19c4468260df273cfe7bc37">00246</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00247"></a>00247         {
<a name="l00248"></a>00248             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00249"></a>00249                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00250"></a>00250                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00251"></a>00251                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00252"></a>00252                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00253"></a>00253         }
<a name="l00254"></a>00254 
<a name="l00255"></a><a class="code" href="classOgre_1_1Vector4.html#a2dd10da814b39dc369ac4f96d0055a54">00255</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00256"></a>00256         {
<a name="l00257"></a>00257             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00258"></a>00258                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00259"></a>00259                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00260"></a>00260                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00261"></a>00261                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00262"></a>00262         }
<a name="l00263"></a>00263 
<a name="l00264"></a><a class="code" href="classOgre_1_1Vector4.html#a28efcff06858b5011bbc4250230539f0">00264</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator + (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00265"></a>00265         {
<a name="l00266"></a>00266             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00267"></a>00267                 lhs.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a> + rhs,
<a name="l00268"></a>00268                 lhs.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a> + rhs,
<a name="l00269"></a>00269                 lhs.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a> + rhs,
<a name="l00270"></a>00270                 lhs.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a> + rhs);
<a name="l00271"></a>00271         }
<a name="l00272"></a>00272 
<a name="l00273"></a><a class="code" href="classOgre_1_1Vector4.html#a4ec63fee2f096c1e845076797d1e140a">00273</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator + (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rhs)
<a name="l00274"></a>00274         {
<a name="l00275"></a>00275             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00276"></a>00276                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00277"></a>00277                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00278"></a>00278                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00279"></a>00279                 lhs + rhs.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00280"></a>00280         }
<a name="l00281"></a>00281 
<a name="l00282"></a><a class="code" href="classOgre_1_1Vector4.html#a3b9ce3e33b491148161ac0e4116e709a">00282</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator - (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lhs, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00283"></a>00283         {
<a name="l00284"></a>00284             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00285"></a>00285                 lhs.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a> - rhs,
<a name="l00286"></a>00286                 lhs.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a> - rhs,
<a name="l00287"></a>00287                 lhs.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a> - rhs,
<a name="l00288"></a>00288                 lhs.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a> - rhs);
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a><a class="code" href="classOgre_1_1Vector4.html#ae2c5e61fcb0521bdea9c8d70069742f9">00291</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> operator - (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rhs)
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>(
<a name="l00294"></a>00294                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>,
<a name="l00295"></a>00295                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>,
<a name="l00296"></a>00296                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>,
<a name="l00297"></a>00297                 lhs - rhs.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>);
<a name="l00298"></a>00298         }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300         <span class="comment">// arithmetic updates</span>
<a name="l00301"></a><a class="code" href="classOgre_1_1Vector4.html#ada0bb188b87a7187e49e9acfa4994a7f">00301</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00302"></a>00302         {
<a name="l00303"></a>00303             x += rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00304"></a>00304             y += rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00305"></a>00305             z += rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00306"></a>00306             w += rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00309"></a>00309         }
<a name="l00310"></a>00310 
<a name="l00311"></a><a class="code" href="classOgre_1_1Vector4.html#acc233206a14cef454dd0d9428848ebfc">00311</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00312"></a>00312         {
<a name="l00313"></a>00313             x -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00314"></a>00314             y -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00315"></a>00315             z -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00316"></a>00316             w -= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00319"></a>00319         }
<a name="l00320"></a>00320 
<a name="l00321"></a><a class="code" href="classOgre_1_1Vector4.html#a4ddc0b778ff8255a715c75dcf9527847">00321</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00322"></a>00322         {
<a name="l00323"></a>00323             x *= fScalar;
<a name="l00324"></a>00324             y *= fScalar;
<a name="l00325"></a>00325             z *= fScalar;
<a name="l00326"></a>00326             w *= fScalar;
<a name="l00327"></a>00327             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00328"></a>00328         }
<a name="l00329"></a>00329 
<a name="l00330"></a><a class="code" href="classOgre_1_1Vector4.html#a37efa8bb4db9148fb43c8238b21c1906">00330</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00331"></a>00331         {
<a name="l00332"></a>00332             x += fScalar;
<a name="l00333"></a>00333             y += fScalar;
<a name="l00334"></a>00334             z += fScalar;
<a name="l00335"></a>00335             w += fScalar;
<a name="l00336"></a>00336             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00337"></a>00337         }
<a name="l00338"></a>00338 
<a name="l00339"></a><a class="code" href="classOgre_1_1Vector4.html#a8a23c96373a8d8163ea5b7819f2b22f3">00339</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00340"></a>00340         {
<a name="l00341"></a>00341             x -= fScalar;
<a name="l00342"></a>00342             y -= fScalar;
<a name="l00343"></a>00343             z -= fScalar;
<a name="l00344"></a>00344             w -= fScalar;
<a name="l00345"></a>00345             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00346"></a>00346         }
<a name="l00347"></a>00347 
<a name="l00348"></a><a class="code" href="classOgre_1_1Vector4.html#abd72d0322c60e4c39121547ff8ddc516">00348</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00349"></a>00349         {
<a name="l00350"></a>00350             x *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00351"></a>00351             y *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00352"></a>00352             z *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00353"></a>00353             w *= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00356"></a>00356         }
<a name="l00357"></a>00357 
<a name="l00358"></a><a class="code" href="classOgre_1_1Vector4.html#a0c4b23241a97373da79afc6c993e1370">00358</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00359"></a>00359         {
<a name="l00360"></a>00360             assert( fScalar != 0.0 );
<a name="l00361"></a>00361 
<a name="l00362"></a>00362             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0f / fScalar;
<a name="l00363"></a>00363 
<a name="l00364"></a>00364             x *= fInv;
<a name="l00365"></a>00365             y *= fInv;
<a name="l00366"></a>00366             z *= fInv;
<a name="l00367"></a>00367             w *= fInv;
<a name="l00368"></a>00368 
<a name="l00369"></a>00369             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00370"></a>00370         }
<a name="l00371"></a>00371 
<a name="l00372"></a><a class="code" href="classOgre_1_1Vector4.html#a4c4def28bfaf96a3326747d2ef2ed08f">00372</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; rkVector )
<a name="l00373"></a>00373         {
<a name="l00374"></a>00374             x /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a>;
<a name="l00375"></a>00375             y /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a>;
<a name="l00376"></a>00376             z /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a>;
<a name="l00377"></a>00377             w /= rkVector.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00378"></a>00378 
<a name="l00379"></a>00379             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00380"></a>00380         }
<a name="l00381"></a>00381 
<a name="l00389"></a><a class="code" href="classOgre_1_1Vector4.html#a14ced50f2a18dd194c3d95d7d031c5dd">00389</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00390"></a>00390 <span class="keyword">        </span>{
<a name="l00391"></a>00391             <span class="keywordflow">return</span> x * vec.<a class="code" href="classOgre_1_1Vector4.html#ac1f14b711795b4d13140e992d9a3e6cf">x</a> + y * vec.<a class="code" href="classOgre_1_1Vector4.html#a4a55a790632b60df0f536efa68de3bfa">y</a> + z * vec.<a class="code" href="classOgre_1_1Vector4.html#a389cf99ed365e8ec1d823c0a0cf52da3">z</a> + w * vec.<a class="code" href="classOgre_1_1Vector4.html#a601896b4f2f5be1d7ccd0ee4a0500237">w</a>;
<a name="l00392"></a>00392         }
<a name="l00394"></a><a class="code" href="classOgre_1_1Vector4.html#ab53a41cf7ae8884b9fbac656d3fef338">00394</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isNaN()<span class="keyword"> const</span>
<a name="l00395"></a>00395 <span class="keyword">        </span>{
<a name="l00396"></a>00396             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(x) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(y) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(z) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(w);
<a name="l00397"></a>00397         }
<a name="l00400"></a>00400         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00401"></a><a class="code" href="classOgre_1_1Vector4.html#a7f9291e487a6dd6abdc8cc6325751cc3">00401</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; v )
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403             o &lt;&lt; <span class="stringliteral">&quot;Vector4(&quot;</span> &lt;&lt; v.x &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; v.y &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; v.z &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; v.w &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00404"></a>00404             <span class="keywordflow">return</span> o;
<a name="l00405"></a>00405         }
<a name="l00406"></a>00406         <span class="comment">// special</span>
<a name="l00407"></a><a class="code" href="classOgre_1_1Vector4.html#a6094638aa9e67551258f70f113d805d9">00407</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> <a class="code" href="classOgre_1_1Vector4.html#a6094638aa9e67551258f70f113d805d9">ZERO</a>;
<a name="l00408"></a>00408     };
<a name="l00412"></a>00412 }
<a name="l00413"></a>00413 <span class="preprocessor">#endif</span>
<a name="l00414"></a>00414 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
